<?php
/**
 * Contact Us Page
 *
 * @package page
 * @copyright Copyright 2003-2012 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version GIT: $Id: Author: DrByte  Sat Jul 21 16:05:31 2012 -0400 Modified in v1.5.1 $
 */

// This should be first line of the script:
$zco_notifier->notify('NOTIFY_HEADER_START_SOCIALS_LOGIN');

require(DIR_WS_MODULES . zen_get_module_directory('require_languages.php'));
$email_address = '';
$redirect_to_login = false;
switch($_GET['id']) {
  case 'facebook':
    require_once('facebook_api/facebook.php');
    $app_id = SOCIALS_LOGIN_FB_APP_ID;
    $app_secret = SOCIALS_LOGIN_FB_APP_SECRET;
    $facebook = new Facebook(array(
      'appId'  => $app_id,
      'secret' => $app_secret,
      'fileUpload' => true,
      'cookie' => true
    ));
    
    // check user login
    $user = $facebook->getUser();
    if (!$user) {
      $loginUrl = $facebook->getLoginUrl(array(
                                      'canvas'    => 1,
                                      'fbconnect' => 0,
                                      'scope' => 'email'
                                    ));
      echo '<script type="text/javascript">top.location.href = "' . $loginUrl . '"</script>';
      exit();
    } else {
      
      // get email from facebook and check this email in the system
      $user = $facebook->api("/me"); 
      $email_address = $user['email'];
      //echo '<pre>';var_dump($user); echo '</pre>';die('here');
    }
    $redirect_to_login = true;  
    break;
  case 'google':
    require_once('google_api/google_open_id.php');
		$handle = GoogleOpenID::getAssociationHandle();
    $googleGateway = GoogleOpenID::createRequest(html_entity_decode(zen_href_link('socials_login', 'id=google')), $handle, true);
    if($_GET['a'] == 'r'){
      $googleGateway->redirect();
      exit();
    } else {
      $googleResponse = GoogleOpenID::getResponse();
      if($googleResponse->success()) {
        $email_address = $googleResponse->email();
      }
    }
    $redirect_to_login = true;  
    break;
  case 'yahoo':
  
    /**
     * OAuth - http://oauth.googlecode.com/svn/code/php/
     */
    require_once('yahoo_api/OAuth/OAuth.php');
    /**
     * Yahoo! PHP5 SDK - http://github.com/yahoo/yos-social-php5/tree/master
     */
    
    /**
     * Require Yahoo! PHP5 SDK libraries
     */
    require_once('yahoo_api/Yahoo/YahooOAuthApplication.class.php');
    
    $yahoo_consumer_key = SOCIALS_LOGIN_YH_CONSUMER_KEY;
    $yahoo_consumer_secret = SOCIALS_LOGIN_YH_CONSUMER_SECRET;
    $yahoo_domain = html_entity_decode(zen_href_link('socials_login', 'id=yahoo'));
    $yahoo_app_id = SOCIALS_LOGIN_YH_APP_ID;
    $oauthapp = new YahooOAuthApplication($yahoo_consumer_key, $yahoo_consumer_secret, $yahoo_app_id, $yahoo_domain);
    if($_GET['a'] == 'r'){
      echo '<script type="text/javascript">top.location.href = "' . $oauthapp->getOpenIDUrl($oauthapp->callback_url) . '"</script>';
      exit();
    } else {
      if ($_GET['openid_mode'] == 'id_res') {
      
        // request token
        $request_token = new YahooOAuthRequestToken($_GET['openid_oauth_request_token'], '');
					
        // exchange request token for access token
        $oauthapp->token = $oauthapp->getAccessToken($request_token);
        
        // store access token for later use
        if ($oauthapp->token->to_string()) {
          $oauthapp->token = YahooOAuthAccessToken::from_string($oauthapp->token->to_string());
          $user = $oauthapp->getProfile();
          if($user->profile->emails->handle) {
            $email_address = $user->profile->emails->handle;
          } else {
            $email_address = $user->profile->emails[0]->handle;
          }
        }
      }
    }
    $redirect_to_login = true;  
    break;
  case 'live':
    
    // https://account.live.com/developers/applications/
    
    $client_key = SOCIALS_LOGIN_LIVE_APP_ID;
    $client_secret = SOCIALS_LOGIN_LIVE_APP_SECRET;
    $redirect_uri = html_entity_decode(zen_href_link('socials_login', 'id=live'));
    
    
    if (!isset($_REQUEST['code']) && !isset($_SESSION['access_token'])) {
      $liveURL = 'https://login.live.com/oauth20_authorize.srf?client_id=' . $client_key . '&scope=wl.basic+wl.emails&response_type=code&redirect_uri=' . $redirect_uri;
      echo '<script type="text/javascript">top.location.href = "' . $liveURL . '"</script>';
      exit();
    } else {
      if(!isset($_SESSION['access_token'])) {
        // Initialize a cURL session
        $ch = curl_init();

        // Set the cURL URL
        curl_setopt($ch, CURLOPT_URL, "https://login.live.com/oauth20_token.srf");

        // The HTTP METHOD is set to POST
        curl_setopt($ch, CURLOPT_POST, TRUE);

        // This option is set to TRUE so that the response
        // doesnot get printed and is stored directly in 
        // the variable
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

        // The POST variables which need to be sent along with the HTTP request
        curl_setopt($ch, CURLOPT_POSTFIELDS, "code=" . $_REQUEST['code'] . "&client_id=" . $client_key . "&client_secret=" . $client_secret . "&redirect_uri=".$redirect_uri."&grant_type=authorization_code");

        // Execute the cURL request		
        $data = curl_exec($ch);

        // Close the cURL connection
        curl_close($ch);

        // Decode the JSON request and remove the access token from it
        $data = json_decode($data);

        $access_token = $data->access_token;

        // Set the session access token
        $_SESSION['access_token'] = $data->access_token;
      } else {
        // If session access token is set
        $access_token = $_SESSION['access_token'];
      }
      // Initialize another cURL session
      $ch = curl_init();

      // Set all the options and execute the session
      curl_setopt($ch, CURLOPT_URL, "https://apis.live.net/v5.0/me?access_token=" . $access_token);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
      $data = curl_exec($ch);
      curl_close($ch);
      // Get the data from the JSON response
      $data = json_decode($data,true);
      
      $email_address = $data['emails']['account'];
      
    }
    $redirect_to_login = true;  
    break;
}

if(!empty($email_address)) {

  // Check if email exists
  $check_customer_query = "SELECT customers_id, customers_firstname, customers_lastname, customers_password,
                                  customers_email_address, customers_default_address_id,
                                  customers_authorization, customers_referral
                         FROM " . TABLE_CUSTOMERS . "
                         WHERE customers_email_address = :emailAddress";

  $check_customer_query  =$db->bindVars($check_customer_query, ':emailAddress', $email_address, 'string');
  $check_customer = $db->Execute($check_customer_query);

  if (!$check_customer->RecordCount()) {
    $error = true;
    $messageStack->add_session('login', 'Error: Sorry, there is no match for your email address.');
  } elseif ($check_customer->fields['customers_authorization'] == '4') {
    // this account is banned
    $zco_notifier->notify('NOTIFY_LOGIN_BANNED');
    $messageStack->add_session('login', 'Error: Access denied.');
  } else {

    if (SESSION_RECREATE == 'True') {
      zen_session_recreate();
    }

    $check_country_query = "SELECT entry_country_id, entry_zone_id
                          FROM " . TABLE_ADDRESS_BOOK . "
                          WHERE customers_id = :customersID
                          AND address_book_id = :addressBookID";

    $check_country_query = $db->bindVars($check_country_query, ':customersID', $check_customer->fields['customers_id'], 'integer');
    $check_country_query = $db->bindVars($check_country_query, ':addressBookID', $check_customer->fields['customers_default_address_id'], 'integer');
    $check_country = $db->Execute($check_country_query);

    $_SESSION['customer_id'] = $check_customer->fields['customers_id'];
    $_SESSION['customer_default_address_id'] = $check_customer->fields['customers_default_address_id'];
    $_SESSION['customers_authorization'] = $check_customer->fields['customers_authorization'];
    $_SESSION['customer_first_name'] = $check_customer->fields['customers_firstname'];
    $_SESSION['customer_last_name'] = $check_customer->fields['customers_lastname'];
    $_SESSION['customer_country_id'] = $check_country->fields['entry_country_id'];
    $_SESSION['customer_zone_id'] = $check_country->fields['entry_zone_id'];

    $sql = "UPDATE " . TABLE_CUSTOMERS_INFO . "
          SET customers_info_date_of_last_logon = now(),
              customers_info_number_of_logons = customers_info_number_of_logons+1
          WHERE customers_info_id = :customersID";

    $sql = $db->bindVars($sql, ':customersID',  $_SESSION['customer_id'], 'integer');
    $db->Execute($sql);
    $zco_notifier->notify('NOTIFY_LOGIN_SUCCESS');

    // bof: contents merge notice
    // save current cart contents count if required
    if (SHOW_SHOPPING_CART_COMBINED > 0) {
      $zc_check_basket_before = $_SESSION['cart']->count_contents();
    }

    // bof: not require part of contents merge notice
    // restore cart contents
    $_SESSION['cart']->restore_contents();
    // eof: not require part of contents merge notice

    // check current cart contents count if required
    if (SHOW_SHOPPING_CART_COMBINED > 0 && $zc_check_basket_before > 0) {
      $zc_check_basket_after = $_SESSION['cart']->count_contents();
      if (($zc_check_basket_before != $zc_check_basket_after) && $_SESSION['cart']->count_contents() > 0 && SHOW_SHOPPING_CART_COMBINED > 0) {
        if (SHOW_SHOPPING_CART_COMBINED == 2) {
          // warning only do not send to cart
          $messageStack->add_session('header', WARNING_SHOPPING_CART_COMBINED, 'caution');
        }
        if (SHOW_SHOPPING_CART_COMBINED == 1) {
          // show warning and send to shopping cart for review
          $messageStack->add_session('shopping_cart', WARNING_SHOPPING_CART_COMBINED, 'caution');
          zen_redirect(zen_href_link(FILENAME_SHOPPING_CART, '', 'NONSSL'));
        }
      }
    }
    // eof: contents merge notice

    if (sizeof($_SESSION['navigation']->snapshot) > 0) {
      //    $back = sizeof($_SESSION['navigation']->path)-2;
      //if (isset($_SESSION['navigation']->path[$back]['page'])) {
      //    if (sizeof($_SESSION['navigation']->path)-2 > 0) {
      $origin_href = zen_href_link($_SESSION['navigation']->snapshot['page'], zen_array_to_string($_SESSION['navigation']->snapshot['get'], array(zen_session_name())), $_SESSION['navigation']->snapshot['mode']);
      //            $origin_href = zen_back_link_only(true);
      $_SESSION['navigation']->clear_snapshot();
      zen_redirect($origin_href);
    } else {
      zen_redirect(zen_href_link(FILENAME_DEFAULT, '', $request_type));
    }
  }
}

if($redirect_to_login === true) {
  // redirect to login page if login fails
  zen_redirect(zen_href_link(FILENAME_LOGIN, '', $request_type));
}


$breadcrumb->add(NAVBAR_TITLE);

// This should be the last line of the script:
$zco_notifier->notify('NOTIFY_HEADER_END_SOCIALS_LOGIN');
